-- Unidad Aritmtico Lgica

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_signed.all;

ENTITY alu IS
GENERIC (n_bits:integer:=16);
PORT(m,n,p,q:IN std_logic;
	 Z,S,C,W:OUT std_logic;
	 BA,BB:IN std_logic_vector(n_bits-1 DOWNTO 0);
	 B1:OUT std_logic_vector(n_bits-1 DOWNTO 0));
END alu;

ARCHITECTURE flujo1 OF alu IS
	CONSTANT uno:std_logic_vector(n_bits-1 DOWNTO 0):="0000000000000001";
	CONSTANT cero:std_logic_vector(n_bits-1 DOWNTO 0):=(OTHERS=>'0');
	
BEGIN
	
	PROCESS(m,n,p,q)
	VARIABLE B1_aux,carry,borrow:std_logic_vector(n_bits-1 DOWNTO 0);
	VARIABLE mnpq:std_logic_vector(3 downto 0);
	VARIABLE ind:INTEGER;
	VARIABLE C_aux,B_aux,nada:std_logic:='0';	

	BEGIN	
		mnpq(0):=q;
		mnpq(1):=p;
		mnpq(2):=n;
		mnpq(3):=m;
		CASE mnpq IS
			WHEN "0000" => B1_aux:=BA;
			WHEN "0011" => B1_aux:=BB;	
			WHEN "0100" => B1_aux:=BB+uno;
			WHEN "0101" => B1_aux:=BB-uno;
			WHEN "0110" => -- suma en comp2, con acarreo
				C_aux:='0';
	   			FOR ind IN 0 TO 15 LOOP
    	   			B1_aux(ind):=BA(ind) XOR BB(ind) XOR C_aux;
	     			C_aux:=(BA(ind) AND BB(ind)) OR (BA(ind) AND C_aux) OR (BB(ind) AND C_aux);
					carry(ind):=C_aux;
				END LOOP; 
	   			C <= C_aux;
				W <= carry(15) xor carry(14);
			WHEN "0111" => -- resta en comp2;
				B_aux:='0';
	   			FOR ind IN 0 TO 15 LOOP
    	   			B1_aux(ind):=BA(ind) XOR BB(ind) XOR B_aux;
	     			B_aux:=(NOT(BA(ind)) AND BB(ind)) OR (NOT(BA(ind)) AND B_aux) OR (BB(ind) AND B_aux);
					borrow(ind):=B_aux;
				END LOOP; 
	   			C<= B_aux; -- el adeudo aparece en el flag de acarreo
				W <= borrow(15) xor borrow(14);			 		
			WHEN "1000" => 
				B1_aux:=BA NAND BB;
			WHEN "1001" =>	--desp.izqda. 
				C <= BA(n_bits-1);
				B1_aux:=BA(n_bits-2 downto 0)&'0';
			WHEN "1010" =>  --desp. dcha. Aqu 'S' siempre es 0
				C <= BA(0);
				B1_aux:='0'&BA(n_bits-1 downto 1);
			WHEN "1011" => --desp.arit.dcha.
				C <= BA(0);
				B1_aux:=BA(n_bits-1)&BA(n_bits-1 downto 1); 
     		WHEN OTHERS => nada:='0';
		END CASE;

		B1<=B1_aux;
		CASE mnpq IS
			WHEN "0110"|"0111"|"1000"|"1001"|"1010"|"1011" => 
				IF B1_aux=cero THEN Z<='1'; 
				ELSE Z<='0';
				END IF;
				S <= B1_aux(n_bits-1);
     		WHEN OTHERS => nada:='0';
		END CASE;

	END PROCESS;

END flujo1;	

-- 258 LCs (22 %).


