-- 15 de Junio de 2001
-- copia de lcc.vhd, para arreglar I0, I1.

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_signed.all;

ENTITY lc IS
PORT(reloj,reset:IN std_logic;
	 FF:IN std_logic_vector(15 downto 0);
	 ireq:IN std_logic;
	 codop,cnd:IN std_logic_vector(3 downto 0);
	 we,ce:OUT std_logic;--seales de Memoria Principal 
	 b,c_1,c_e,d,e,f,g,h,i,ir0,ir1,ir2:OUT std_logic;
	 k,l,m,n,p,q,s_FF,t,u,v,x,y:OUT std_logic);--Tambin habr salidas para I/O
END lc;									

ARCHITECTURE x1 OF lc IS

COMPONENT decod
PORT(codop:IN std_logic_vector(3 downto 0);
	 I0,I1,I2,I3,I4,I5,I6,I7,I8,I9,IA,IB,IC,ID,IE,I_F:OUT std_logic);
END COMPONENT;

SIGNAL cl,esp,I0,I1,I2,I3,I4,I5,I6,I7,I8,I9,IA,IB,IC,ID,IE,I_F:std_logic;

BEGIN
	
	PROCESS(reloj,reset,cl,esp)
	TYPE estados IS (c0,c1,c2,c3,c4,c5,c6,c7,c8);
	VARIABLE estado:estados;
	BEGIN
		IF reset='1' THEN estado:=c0;
		ELSIF reloj='1' AND reloj'event THEN
			IF cl='1' THEN
				cl <= '0';
				estado:=c1;
			END IF;
			CASE estado IS
			WHEN c0 =>
				ir0 <= '1';-- Para inicializar PC (lo inicializo a '0000'h)
				ce <= '1'; -- Inicialmente la MP est desactivada
				we <= '1'; -- y en modo lectura por si las moscas
				g <= '1';
				estado:=c1;		
			WHEN c1 =>
				IF esp='1' THEN estado:=c1;
				ELSIF ireq='1' THEN -- Si hay interrupcin
					ir2 <= '1';--LLevar a IR<=D000'h
					i <= '1';
					ir0 <= '0';	
					estado:=c4;
				ELSE -- me anticipo a c1. Hago AR<=alu<=PC
					b <= '1'; -- BB<=PC
					h <= '0';
			
					c_e <= '1';-- Se cierra con las aritmticas.					
					e <= '1'; -- RT<=PC

					k <= '0';
					l <= '0';
	
					m <= '0';
					n <= '0';
					p <= '1';
					q <= '1';
	
					f <= '1'; -- aqu es donde se escribe en AR	
					estado:=c2;
				END IF;
			WHEN c2 => -- DR<=M(AR); PC<=RT+1
				c_1 <= '1';-- depende de cuando est el dato disponible de 
				d <= '1';  -- Memoria Principal, esto ir aqu o en el siguiente
						   -- estado.			

				ce <= '0';--Activamos MP
				we <= '1';-- DR<=M(AR)

				m <= '0'; -- PC<=RT+1
				n <= '1';
				p <= '0';
				q <= '0';

				g <= '1';--Aqu se escribe en PC la suma RT+1				

				ir1 <= '0'; 
				ir0 <= '0';	
				f <= '0';
				e <= '0';
				estado:=c3;
			WHEN c3 => 
				ce <= '1';-- desactivamos la MP

				g <= '0';
				d <= '0';
				e <= '1';

				b <= '0';-- BB<=DR
				h <= '1';
	
				k <= '0';
				l <= '0';

				m <= '0';
				n <= '0';
				p <= '1';
				q <= '1';
				ir2 <= '0'; 
	
				i <= '1';--IR<=B1
				estado:=c4;
			WHEN c4 => 
				i <= '0';
				IF IC='1' OR ID='1' THEN
					IF FF(CONV_INTEGER(cnd))='1' THEN
						u <= ID;
						v <= IC;
						x <= IC;			
						
						b <= '0';
						h <= '0';

						e <= IC OR ID;

						m <= '0';
						n <= ID;
						p <= IC;
						q <= IC OR ID;
	
						g <= IC;
						estado:=c5;
					ELSE 
						cl <= '1';
						estado:=c5;	
					END IF;
				ELSE
					u <= IE;-- las aritmticas no intervienen, tienen uvx=000
					v <= I0 OR I1 OR I2 OR I3 OR I5 OR I9 OR IA OR IB;
					x <= I0 OR I1;			

					b <= I2 OR I4 OR I5;
					h <= I2 OR I4 OR I5;

					k <= '0';
					l <= I2 OR I3 OR I4 OR I5;

					e <= I0 OR I1 OR I6 OR I7 OR I8 OR IE;-- una vez que lee de memoria, 
													      -- almacena en RT.
					m <= '0';
					n <= ID;
					p <= IC OR IE;
					q <= IC OR ID OR IE;

					f <= I4 OR I5 OR IE;--Se escribe en AR.

					esp <= I_F;
					cl <= I_F;
					estado:=c5;	
				END IF;
			WHEN c5 => 
				g <= '0';
				e <= I3 OR I5;--RT<=RF(I3)
	
				x <= I6 OR I7 OR I8;-- 'u' y 'v' no se modifican		
	
				b <= I0 OR I1 OR I2;
				h <= I0 OR I1 OR I2;

				k <= '0';
				l <= I0 OR I1 OR I2 OR I3;

				c_e <= NOT(I9 OR IA OR IB);
	
				m <= I9 OR IA OR IB;
				n <= I0 OR I1 OR IE OR ID;
				p <= I0 OR I1 OR I5 OR IA OR IB;
				q <= I5 OR I9 OR IB OR ID;

				s_FF <= I9 OR IA OR IB;

				y <= I2 OR I3 OR I9 OR IA OR IB OR ID OR IE;
				cl <= IC;
				f <= I0 OR I1 OR ID;--Se escribe en AR.
				
				ce <= NOT(IE);--se activa para IE, sigue en lectura
				c_1 <= NOT(I5);
				d <= I4 OR I5 OR IE;--DR<=IP(AR) para I4;DR<=M(AR) para IE
				
				estado:=c6;
			WHEN c6 => --Aqu hago c7 de I0,I1,I4,I5 e ID
				b <= I3 OR ID;
				h <= I3 OR I4 OR IE;

				k <= I3;
				l <= '0';
				
				m <= I0 OR I8;
				n <= I0 OR I3 OR I6 OR I7;
				p <= I0 OR I1 OR I3 OR I4 OR I6 OR I7 OR ID OR IE;
				q <= I0 OR I1 OR I4 OR I7 OR ID OR IE;
				
				s_FF <= I6 OR I7 OR I8;

				t <= I5;--OP(AR)<=DR, para I5

				g <= IE;

				u <= IE ;
				v <= I0 OR I1 OR I3 OR I4 OR I6 OR I7 OR I8;-- para escribir en rx.
				x <= '0';			

				ce <= NOT(I0);--Activamos MP para I0
				c_1 <= NOT(I1 OR ID);-- depende de cuando est el dato disponible de 
				d <= I0 OR I1 OR ID;-- Memoria Principal, esto ir aqu o en el siguiente
						 		    -- estado.			
				f <= '0';

				e <= I0 OR I1 OR I4 OR ID OR IE;		
				c_e <= I3;	

				y <= I3 OR I4;
				cl <= I2 OR I9 OR IA OR IB;
				estado:=c7;			
			WHEN c7 =>
				t <= I1 OR ID;
				ce <= NOT(I1 OR ID);--Activamos MP para I1,ID
				we <= NOT(I1 OR ID);-- M(AR)<=DR, se escribe cuando 'we' es bajo 
				d <= '0';	
				IF ireq='1' THEN
					ir1 <= '1';--PC<=F800'H
					g <= '1';
				ELSE		
					c_e <= '0'; 
					s_FF <= '0';

					u <= '0';
					v <= I0 OR I3 OR I6 OR I7 OR I8 OR ID;-- para escribir en rx.
					x <= ID;			

					b <= I3;
					h <= I0 OR I3;

					k <= I3;
					l <= '0';

					e <=  I0 OR ID;
					f <= '0';

					g <= ID;

					m <= I8;
					n <= I3 OR I6 OR I7;
					p <= I0 OR I3 OR I6 OR I7 OR ID;
					q <= I0 OR I7 OR ID;
	
					y <= I0 OR I6 OR I7 OR I8;--Aqu escribe el resultado
					cl <= I3 OR I4 OR I5 OR IE;
				END IF;
				estado:=c8;
			WHEN c8 =>
				ce <= '1';-- desactivamos la MP y la dejamos en modo lectura
				we <= '1';
				c_e <= '0';
				e <= '0';
				g <= '0';
				t <= '0';
				y <= '0';
				cl <= I0 OR I1 OR I6 OR I7 OR I8 OR ID;
				estado:=c1;
			END CASE;
		END IF;
	END PROCESS;

decodificador:decod
		      PORT MAP (codop=>codop,I0=>I0,I1=>I1,I2=>I2,I3=>I3,I4=>I4,I5=>I5,I6=>I6,
					    I7=>I7,I8=>I8,I9=>I9,IA=>IA,IB=>IB,IC=>IC,ID=>ID,IE=>IE,I_F=>I_F);

END x1;	--291 LCs (25 %)

-- Funcionan todas pero consumen ms ciclos de los previstos. 
-- Intentar reducirlos... no he podido reducirlos.

-- Gurdalo como nueva semilla. FAST=>SPEED=5
